summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorWilson Michaels <thebitpit@eartlink.net>2019-09-17 14:53:35 -0500
committerJoonas Niilola <juippis@gentoo.org>2019-09-20 19:17:51 +0300
commitcb34a5497be5bc3642f0fc05b59bab53ca7e0ca1 (patch)
treeaff9089067ce2048ddee55f9dae1b66c8cb04ec1 /media-tv
parentacct-user/mythtv: New (UID 117) (diff)
downloadgentoo-cb34a5497be5bc3642f0fc05b59bab53ca7e0ca1.tar.gz
gentoo-cb34a5497be5bc3642f0fc05b59bab53ca7e0ca1.tar.bz2
gentoo-cb34a5497be5bc3642f0fc05b59bab53ca7e0ca1.zip
media-tv/mythtv: Bump to 30.0_p2019080 on fixes/30 branch
EAPI 7 Signed-off-by: Wilson Michaels <thebitpit@eartlink.net> Closes: https://github.com/gentoo/gentoo/pull/12818 Signed-off-by: Joonas Niilola <juippis@gentoo.org>
Diffstat (limited to 'media-tv')
-rw-r--r--media-tv/mythtv/Manifest1
-rw-r--r--media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_Dereferencing_type-punned_pointer.patch34
-rw-r--r--media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_unitialized_variables.patch22
-rw-r--r--media-tv/mythtv/files/mythtv-30.0_p20190808-cast_constants_to_short.patch365
-rw-r--r--media-tv/mythtv/files/mythtv-30.0_p20190808-respect_LDFLAGS.patch14
-rw-r--r--media-tv/mythtv/metadata.xml75
-rw-r--r--media-tv/mythtv/mythtv-30.0_p20190808.ebuild420
7 files changed, 888 insertions, 43 deletions
diff --git a/media-tv/mythtv/Manifest b/media-tv/mythtv/Manifest
index ab544b3114fd..fe458fa15537 100644
--- a/media-tv/mythtv/Manifest
+++ b/media-tv/mythtv/Manifest
@@ -1 +1,2 @@
DIST mythtv-29.1-r1.tar.gz 105657217 BLAKE2B 9d42464b0c75c2d3a359b528e3f7917cfb281f48451167afc6517caa9702da44fce2d48566fd902ec08af35117232113b4d499e2c9a3cf2ad2634d91cf532ca7 SHA512 0eadc37661d9fa93a63c0f425cd43d43533889b0afcea1478b2645e083ba6c96eebf2eec088db1ed6f0a0727c03b7c90c0c18b83c194d630dda3bac45bca5d87
+DIST mythtv-30.0_p20190808.tar.gz 101208060 BLAKE2B af8966dd6353fc514c9a95083f28e8b7b19f16e1bd5a4f7590a946c306bf16a09f0028c76da975e423136834f8f06d7f2a570b43957ef4ae5e42ee241b579f0a SHA512 c02371c0b2162556e40a560a0fd9cb121f46f2ccedbc2ca74cd03aa9caf2b7ea4bbaa09ae6320eb782f932190f449e7fdd274a6d6ba9676e5fd9b7f5432632a2
diff --git a/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_Dereferencing_type-punned_pointer.patch b/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_Dereferencing_type-punned_pointer.patch
new file mode 100644
index 000000000000..bc0751c887c3
--- /dev/null
+++ b/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_Dereferencing_type-punned_pointer.patch
@@ -0,0 +1,34 @@
+--- a/libs/libmythfreemheg/Programs.cpp
++++ b/libs/libmythfreemheg/Programs.cpp
+@@ -232,7 +232,10 @@ void MHResidentProgram::CallProgram(bool fIsFork, const MHObjectRef &success, co
+ for (int i = 0; i < format.Size(); i++)
+ {
+ unsigned char ch = format.GetAt(i);
+- char buffer[5]; // Largest text is 4 chars for a year + null terminator
++ // Largest text is 4 chars for a year + null terminator
++ // But... adding a constant to the value might be 5 chars + null terminator
++ // Using 6 gets rid of compiler warning
++ char buffer[6];
+
+ if (ch == '%')
+ {
+@@ -249,16 +252,16 @@ void MHResidentProgram::CallProgram(bool fIsFork, const MHObjectRef &success, co
+ switch (ch)
+ {
+ case 'Y':
+- sprintf(buffer, "%04d", timeStr->tm_year + 1900);
++ sprintf(buffer, "%04d", (unsigned short)(timeStr->tm_year + 1900));
+ break;
+ case 'y':
+ sprintf(buffer, "%02d", timeStr->tm_year % 100);
+ break;
+ case 'X':
+- sprintf(buffer, "%02d", timeStr->tm_mon + 1);
++ sprintf(buffer, "%02d", (unsigned short)(timeStr->tm_mon + 1));
+ break;
+ case 'x':
+- sprintf(buffer, "%1d", timeStr->tm_mon + 1);
++ sprintf(buffer, "%1d", (unsigned short)(timeStr->tm_mon + 1));
+ break;
+ case 'D':
+ sprintf(buffer, "%02d", timeStr->tm_mday);
diff --git a/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_unitialized_variables.patch b/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_unitialized_variables.patch
new file mode 100644
index 000000000000..db296242515c
--- /dev/null
+++ b/media-tv/mythtv/files/mythtv-30.0_p20190808-Fix_unitialized_variables.patch
@@ -0,0 +1,22 @@
+--- a/libs/libmythtv/eitfixup.cpp
++++ b/libs/libmythtv/eitfixup.cpp
+@@ -842,7 +842,7 @@ void EITFixUp::SetUKSubtitle(DBEventEIT &event) const
+ void EITFixUp::FixUK(DBEventEIT &event) const
+ {
+ int position1;
+- int position2;
++ int position2 = 0;
+ QString strFull;
+
+ bool isMovie = event.m_category.startsWith("Movie",Qt::CaseInsensitive) ||
+--- a/libs/libmythui/mythuitext.cpp
++++ b/libs/libmythui/mythuitext.cpp
+@@ -1058,7 +1058,7 @@ int MythUIText::MoveCursor(int lines)
+ int lineCount = 0;
+ int currPos = 0;
+ int layoutStartPos = 0;
+- int xPos;
++ int xPos = 0;
+
+ for (int x = 0; x < m_Layouts.count(); x++)
+ {
diff --git a/media-tv/mythtv/files/mythtv-30.0_p20190808-cast_constants_to_short.patch b/media-tv/mythtv/files/mythtv-30.0_p20190808-cast_constants_to_short.patch
new file mode 100644
index 000000000000..572f4e2b7574
--- /dev/null
+++ b/media-tv/mythtv/files/mythtv-30.0_p20190808-cast_constants_to_short.patch
@@ -0,0 +1,365 @@
+--- a/libs/libmyth/test/test_audioutils/test_audioutils.h
++++ b/libs/libmyth/test/test_audioutils/test_audioutils.h
+@@ -204,42 +204,48 @@ class TestAudioUtils: public QObject
+ arrays1[i] = j;
+ }
+
+- uint32_t pattern = 0xbcbcbcbc;
+- arrays2[offsetshort-4] = *(short*)&pattern;
+- arrays2[offsetshort-3] = *(short*)&pattern;
+- arrays2[offsetshort-2] = *(short*)&pattern;
+- arrays2[offsetshort-1] = *(short*)&pattern;
+- arrayf[offsetfloat-4] = *(float*)&pattern;
+- arrayf[offsetfloat-3] = *(float*)&pattern;
+- arrayf[offsetfloat-2] = *(float*)&pattern;
+- arrayf[offsetfloat-1] = *(float*)&pattern;
+- arrays2[SAMPLES+offsetshort+0] = *(short*)&pattern;
+- arrays2[SAMPLES+offsetshort+1] = *(short*)&pattern;
+- arrays2[SAMPLES+offsetshort+2] = *(short*)&pattern;
+- arrays2[SAMPLES+offsetshort+3] = *(short*)&pattern;
+- arrayf[SAMPLES+offsetfloat+0] = *(float*)&pattern;
+- arrayf[SAMPLES+offsetfloat+1] = *(float*)&pattern;
+- arrayf[SAMPLES+offsetfloat+2] = *(float*)&pattern;
+- arrayf[SAMPLES+offsetfloat+3] = *(float*)&pattern;
++ const union
++ {
++ uint32_t pattern;
++ short shortpattern;
++ float floatpattern;
++ } pattern = { .pattern = 0xbcbcbcbc };
++
++ arrays2[offsetshort-4] = *&pattern.shortpattern;
++ arrays2[offsetshort-3] = *&pattern.shortpattern;
++ arrays2[offsetshort-2] = *&pattern.shortpattern;
++ arrays2[offsetshort-1] = *&pattern.shortpattern;
++ arrayf[offsetfloat-4] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-3] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-2] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-1] = *(float*)&pattern.floatpattern;
++ arrays2[SAMPLES+offsetshort+0] = *&pattern.shortpattern;
++ arrays2[SAMPLES+offsetshort+1] = *&pattern.shortpattern;
++ arrays2[SAMPLES+offsetshort+2] = *&pattern.shortpattern;
++ arrays2[SAMPLES+offsetshort+3] = *&pattern.shortpattern;
++ arrayf[SAMPLES+offsetfloat+0] = *(float*)&pattern.floatpattern;
++ arrayf[SAMPLES+offsetfloat+1] = *(float*)&pattern.floatpattern;
++ arrayf[SAMPLES+offsetfloat+2] = *(float*)&pattern.floatpattern;
++ arrayf[SAMPLES+offsetfloat+3] = *(float*)&pattern.floatpattern;
+
+ // sanity tests
+ QCOMPARE(SAMPLES*2, SAMPLES * ISIZEOF(arrays1[0]));
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+3],pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-4],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-3],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-2],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-1],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+0],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+1],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+2],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+3],*(short*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-4],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-3],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-2],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-1],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+0],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+1],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+2],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+3],*&pattern.shortpattern);
+ QCOMPARE(arrayf+4,&arrayf[4]);
+ QCOMPARE(arrays2+4,&arrays2[4]);
+
+@@ -248,22 +254,22 @@ class TestAudioUtils: public QObject
+ int val2 = AudioOutputUtil::fromFloat(FORMAT_S16, arrays2+offsetshort, arrayf+offsetfloat, SAMPLES * ISIZEOF(float));
+ QCOMPARE(val2, SAMPLES * ISIZEOF(short));
+
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+3],pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-4],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-3],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-2],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[offsetshort-1],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+0],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+1],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+2],*(short*)&pattern);
+- QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+3],*(short*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SAMPLES+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-4],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-3],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-2],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[offsetshort-1],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+0],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+1],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+2],*&pattern.shortpattern);
++ QCOMPARE(*(short*)&arrays2[SAMPLES+offsetshort+3],*&pattern.shortpattern);
+
+ av_free(arrays1);
+ av_free(arrays2);
+@@ -505,42 +511,48 @@ class TestAudioUtils: public QObject
+ arrays1[i] = j;
+ }
+
+- uint32_t pattern = 0xbcbcbcbc;
+- arrays2[offsetuchar-4] = *(uchar*)&pattern;
+- arrays2[offsetuchar-3] = *(uchar*)&pattern;
+- arrays2[offsetuchar-2] = *(uchar*)&pattern;
+- arrays2[offsetuchar-1] = *(uchar*)&pattern;
+- arrayf[offsetfloat-4] = *(float*)&pattern;
+- arrayf[offsetfloat-3] = *(float*)&pattern;
+- arrayf[offsetfloat-2] = *(float*)&pattern;
+- arrayf[offsetfloat-1] = *(float*)&pattern;
+- arrays2[SIZEARRAY+offsetuchar+0] = *(uchar*)&pattern;
+- arrays2[SIZEARRAY+offsetuchar+1] = *(uchar*)&pattern;
+- arrays2[SIZEARRAY+offsetuchar+2] = *(uchar*)&pattern;
+- arrays2[SIZEARRAY+offsetuchar+3] = *(uchar*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+0] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+1] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+2] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+3] = *(float*)&pattern;
++ const union
++ {
++ uint32_t pattern;
++ uchar ucharpattern;
++ float floatpattern;
++ } pattern = { .pattern = 0xbcbcbcbc };
++
++ arrays2[offsetuchar-4] = *(uchar*)&pattern.ucharpattern;
++ arrays2[offsetuchar-3] = *(uchar*)&pattern.ucharpattern;
++ arrays2[offsetuchar-2] = *(uchar*)&pattern.ucharpattern;
++ arrays2[offsetuchar-1] = *(uchar*)&pattern.ucharpattern;
++ arrayf[offsetfloat-4] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-3] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-2] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-1] = *(float*)&pattern.floatpattern;
++ arrays2[SIZEARRAY+offsetuchar+0] = *(uchar*)&pattern.ucharpattern;
++ arrays2[SIZEARRAY+offsetuchar+1] = *(uchar*)&pattern.ucharpattern;
++ arrays2[SIZEARRAY+offsetuchar+2] = *(uchar*)&pattern.ucharpattern;
++ arrays2[SIZEARRAY+offsetuchar+3] = *(uchar*)&pattern.ucharpattern;
++ arrayf[SIZEARRAY+offsetfloat+0] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+1] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+2] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+3] = *(float*)&pattern.floatpattern;
+
+ // sanity tests
+ QCOMPARE(SIZEARRAY*1, SIZEARRAY * ISIZEOF(arrays1[0]));
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-4],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-3],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-2],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-1],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+0],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+1],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+2],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+3],*(uchar*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-4],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-3],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-2],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-1],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+0],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+1],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+2],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+3],*(uchar*)&pattern.ucharpattern);
+ QCOMPARE(arrayf+4,&arrayf[4]);
+ QCOMPARE(arrays2+4,&arrays2[4]);
+
+@@ -549,22 +561,22 @@ class TestAudioUtils: public QObject
+ int val2 = AudioOutputUtil::fromFloat(FORMAT_U8, arrays2+offsetuchar, arrayf+offsetfloat, SIZEARRAY * ISIZEOF(float));
+ QCOMPARE(val2, SIZEARRAY * ISIZEOF(uchar));
+
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-4],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-3],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-2],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[offsetuchar-1],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+0],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+1],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+2],*(uchar*)&pattern);
+- QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+3],*(uchar*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-4],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-3],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-2],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[offsetuchar-1],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+0],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+1],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+2],*(uchar*)&pattern.ucharpattern);
++ QCOMPARE(*(uchar*)&arrays2[SIZEARRAY+offsetuchar+3],*(uchar*)&pattern.ucharpattern);
+
+ av_free(arrays1);
+ av_free(arrays2);
+@@ -686,42 +698,48 @@ class TestAudioUtils: public QObject
+ arrays1[i] = j;
+ }
+
+- uint32_t pattern = 0xbcbcbcbc;
+- arrays2[offsetint32_t-4] = *(int32_t*)&pattern;
+- arrays2[offsetint32_t-3] = *(int32_t*)&pattern;
+- arrays2[offsetint32_t-2] = *(int32_t*)&pattern;
+- arrays2[offsetint32_t-1] = *(int32_t*)&pattern;
+- arrayf[offsetfloat-4] = *(float*)&pattern;
+- arrayf[offsetfloat-3] = *(float*)&pattern;
+- arrayf[offsetfloat-2] = *(float*)&pattern;
+- arrayf[offsetfloat-1] = *(float*)&pattern;
+- arrays2[SIZEARRAY+offsetint32_t+0] = *(int32_t*)&pattern;
+- arrays2[SIZEARRAY+offsetint32_t+1] = *(int32_t*)&pattern;
+- arrays2[SIZEARRAY+offsetint32_t+2] = *(int32_t*)&pattern;
+- arrays2[SIZEARRAY+offsetint32_t+3] = *(int32_t*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+0] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+1] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+2] = *(float*)&pattern;
+- arrayf[SIZEARRAY+offsetfloat+3] = *(float*)&pattern;
++ const union
++ {
++ uint32_t pattern;
++ int32_t int32pattern;
++ float floatpattern;
++ } pattern = { .pattern = 0xbcbcbcbc };
++
++ arrays2[offsetint32_t-4] = *(int32_t*)&pattern.int32pattern;
++ arrays2[offsetint32_t-3] = *(int32_t*)&pattern.int32pattern;
++ arrays2[offsetint32_t-2] = *(int32_t*)&pattern.int32pattern;
++ arrays2[offsetint32_t-1] = *(int32_t*)&pattern.int32pattern;
++ arrayf[offsetfloat-4] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-3] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-2] = *(float*)&pattern.floatpattern;
++ arrayf[offsetfloat-1] = *(float*)&pattern.floatpattern;
++ arrays2[SIZEARRAY+offsetint32_t+0] = *(int32_t*)&pattern.int32pattern;
++ arrays2[SIZEARRAY+offsetint32_t+1] = *(int32_t*)&pattern.int32pattern;
++ arrays2[SIZEARRAY+offsetint32_t+2] = *(int32_t*)&pattern.int32pattern;
++ arrays2[SIZEARRAY+offsetint32_t+3] = *(int32_t*)&pattern.int32pattern;
++ arrayf[SIZEARRAY+offsetfloat+0] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+1] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+2] = *(float*)&pattern.floatpattern;
++ arrayf[SIZEARRAY+offsetfloat+3] = *(float*)&pattern.floatpattern;
+
+ // sanity tests
+ QCOMPARE(SIZEARRAY*4, SIZEARRAY * ISIZEOF(arrays1[0]));
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-4],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-3],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-2],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-1],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+0],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+1],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+2],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+3],*(int32_t*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-4],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-3],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-2],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-1],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+0],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+1],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+2],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+3],*(int32_t*)&pattern.int32pattern);
+ QCOMPARE(arrayf+4,&arrayf[4]);
+ QCOMPARE(arrays2+4,&arrays2[4]);
+
+@@ -730,22 +748,22 @@ class TestAudioUtils: public QObject
+ int val2 = AudioOutputUtil::fromFloat(FORMAT_S32, arrays2+offsetint32_t, arrayf+offsetfloat, SIZEARRAY * ISIZEOF(float));
+ QCOMPARE(val2, SIZEARRAY * ISIZEOF(int32_t));
+
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],pattern);
+- QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-4],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-3],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-2],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-1],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+0],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+1],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+2],*(int32_t*)&pattern);
+- QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+3],*(int32_t*)&pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-4],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[offsetfloat-1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+0],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+1],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+2],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(uint32_t*)&arrayf[SIZEARRAY+offsetfloat+3],*(uint32_t*)&pattern.pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-4],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-3],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-2],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[offsetint32_t-1],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+0],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+1],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+2],*(int32_t*)&pattern.int32pattern);
++ QCOMPARE(*(int32_t*)&arrays2[SIZEARRAY+offsetint32_t+3],*(int32_t*)&pattern.int32pattern);
+
+ av_free(arrays1);
+ av_free(arrays2);
diff --git a/media-tv/mythtv/files/mythtv-30.0_p20190808-respect_LDFLAGS.patch b/media-tv/mythtv/files/mythtv-30.0_p20190808-respect_LDFLAGS.patch
new file mode 100644
index 000000000000..8bfc2796cffe
--- /dev/null
+++ b/media-tv/mythtv/files/mythtv-30.0_p20190808-respect_LDFLAGS.patch
@@ -0,0 +1,14 @@
+--- a/configure
++++ b/configure
+@@ -7919,9 +7919,9 @@ EOF
+ #echo "endif # FFMPEG_CONFIG_MAK" >> $TMPMAK
+
+ # Should be done on all platforms, but for the time being limit it to mac only
+-if enabled darwin; then
++#if enabled darwin; then
+ echo "QMAKE_LFLAGS+=\"$LDFLAGS\"" >> $TMPMAK
+-fi
++#fi
+
+ cp_if_changed $TMPH $MYTH_CONFIG_H
+
diff --git a/media-tv/mythtv/metadata.xml b/media-tv/mythtv/metadata.xml
index 2c054c79fe69..f6172ecf9665 100644
--- a/media-tv/mythtv/metadata.xml
+++ b/media-tv/mythtv/metadata.xml
@@ -1,52 +1,41 @@
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
- <!-- maintainer-needed -->
+ <maintainer type="person">
+ <email>thebitpit@earthlink.net</email>
+ <name>Wilson Michaels</name>
+ </maintainer>
+ <maintainer type="project">
+ <email>proxy-maint@gentoo.org</email>
+ <name>Proxy Maintainers</name>
+ </maintainer>
<use>
- <flag name="alsa">Allows MythTV to directly output sound to ALSA devices,
- this is needed if you are using ALSA dmix or SPDIF. Note, you will have
- to physically type your device into the MythTV configuration since it
- will only give you /dev/dsp devices in the drop down.</flag>
- <flag name="altivec">Builds ffmpeg's codec libraries with altivec
- support.</flag>
- <flag name="autostart">Uses a custom autostart configuration gleaned from
- experience with MythTV since its early versions and discussed with
- other MythTV maintainers and users. Does not rely on KDE being installed
- like most methods do.</flag>
- <flag name="bluray">Pulls in libbluray for BluRay support.</flag>
- <flag name="cec">Allows you to control CEC enabled TVs via HDMI. Currently
- requires a USB based CEC -&gt; HDMI injector between your TV and video
- card since no graphics drivers support CEC natively.</flag>
- <flag name="crystalhd">Allows you to utilize a Broadcom CrystalHD hardware
- based video decoder to improve the performance of video decode.</flag>
- <flag name="debug">Instructs Qt to use the 'debug' target instead of
- 'release' target. If your MythTV is crashing or you need a backtrace,
- you need to compile it with this option otherwise the debugging data is
- useless.</flag>
- <flag name="egl">Support EGL video output.</flag>
+ <flag name="alsa">Allows MythTV to directly output sound to ALSA devices</flag>
+ <flag name="asi">Support for DVEO ASI recorder</flag>
+ <flag name="autostart">Use a custom autostart configuration</flag>
+ <flag name="bluray">Use the system libbluray for BluRay support</flag>
+ <flag name="cec">Allows control of CEC enabled TVs via HDMI</flag>
+ <flag name="ceton">Ceton InfiniTV 4 a CableCARD-enabled tuner support</flag>
+ <flag name="crystalhd">Broadcom CrystalHD hardware support</flag>
+ <flag name="debug">Instructs Qt to use the 'debug' target</flag>
+ <flag name="egl">EGL video output support</flag>
<flag name="fftw">Support visualizations via <pkg>sci-libs/fftw</pkg></flag>
+ <flag name="hdhomerun">Silicondust USA Inc.network-attached tuner support</flag>
+ <flag name="hdpvr">Hauppauge HD-PVR?</flag>
<flag name="hls">HTTP Live Streaming support</flag>
- <flag name="ieee1394">Allows MythTV to communicate and use Firewire enabled
- Cable boxes. These are typically found in the United States, where such
- support is required by law. This will also install Firewire test
- programs and external channel changers if the internal changer does not
- work.</flag>
- <flag name="jack">Allows MythTV to use JACK as your sound output device. You
- will have to manually configure the path to your JACK settings.</flag>
- <flag name="lcd">Tells MythTV that you have an instance of
- <pkg>app-misc/lcdproc</pkg> configured on your machine and it should
- output information such as current time, show name, episode name, etc to
- that LCD.</flag>
- <flag name="lirc">Adds LIRC support directly to MythTV allowing for built in
- control via a LIRC device.</flag>
- <flag name="mythlogserver">Enable support for syslog and file logging. Not
- used with systemd.</flag>
- <flag name="perl">Builds the perl bindings for MythTV. Allows you to write
- scripts in Perl to control your MythTV setup or communicate with
- it.</flag>
- <flag name="wrapper">Use Ubuntu mythtfrontend wrapper.</flag>
- <flag name="xmltv">Pulls in the <pkg>media-tv/xmltv</pkg> TV listing
- grabbers for users not using Schedules Direct.</flag>
+ <flag name="ieee1394">Firewire enabled Cable boxe support</flag>
+ <flag name="ivtv">Support kernel driver for the iTVC15 family of MPEG codecs</flag>
+ <flag name="jack">Allows MythTV to use JACK as your sound output device</flag>
+ <flag name="java">BD-J support for Blu-ray discs</flag>
+ <flag name="lcd">Enable use of <pkg>app-misc/lcdproc</pkg> data display</flag>
+ <flag name="lirc">LIRC remote control device support</flag>
+ <flag name="mythlogserver">Enable support for syslog and file logging</flag>
+ <flag name="perl">Build the perl bindings for MythTV</flag>
+ <flag name="vbox">V@Box Communications network-attached tuner devices support</flag>
+ <flag name="vpx">Enable VP8/VP9 support for <pkg>media-libs/libvpx</pkg></flag>
+ <flag name="wrapper">Use Ubuntu mythtfrontend wrapper</flag>
+ <flag name="x265">Enable h265 encoding using x265</flag>
+ <flag name="xmltv">Support <pkg>media-tv/xmltv</pkg> TV listing - not used by Schedules Direct]</flag>
</use>
<upstream>
<remote-id type="github">MythTV/mythtv</remote-id>
diff --git a/media-tv/mythtv/mythtv-30.0_p20190808.ebuild b/media-tv/mythtv/mythtv-30.0_p20190808.ebuild
new file mode 100644
index 000000000000..1e8752cdcda3
--- /dev/null
+++ b/media-tv/mythtv/mythtv-30.0_p20190808.ebuild
@@ -0,0 +1,420 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python2_7 )
+
+BACKPORTS="5cde0578d84926171b20c8f7e95a101e9b0b9457" # August 8, 2019
+
+MY_P=${P%_p*}
+MY_PV=${PV%_p*}
+
+inherit eutils flag-o-matic python-single-r1 qmake-utils readme.gentoo-r1 systemd vcs-snapshot
+
+MYTHTV_BRANCH="fixes/${P%.*}"
+
+DESCRIPTION="Open Source DVR and media center hub"
+HOMEPAGE="https://www.mythtv.org"
+SRC_URI="https://github.com/MythTV/mythtv/archive/${BACKPORTS}.tar.gz -> ${P}.tar.gz"
+
+LICENSE="GPL-2+"
+KEYWORDS="~amd64 ~x86"
+SLOT="0/${PV}"
+
+IUSE_INPUT_DEVICES="input_devices_joystick"
+IUSE_VIDEO_CAPTURE_DEVICES="v4l ivtv ieee1394 hdpvr hdhomerun vbox ceton"
+IUSE="alsa altivec asi autostart bluray cdda cdr cec crystalhd debug dvd dvb egl exif fftw jack java
+ +lame lcd libass lirc +opengl oss perl pulseaudio python raw systemd vaapi vdpau vpx
+ +wrapper x264 x265 +xml xmltv +xvid +X zeroconf
+ ${IUSE_INPUT_DEVICES} ${IUSE_VIDEO_CAPTURE_DEVICES}"
+REQUIRED_USE="
+ python? ( ${PYTHON_REQUIRED_USE} )
+ bluray? ( xml )
+ cdr? ( cdda )
+"
+
+# Some of the QA tests fail -- fix in next revision
+RESTRICT="test"
+
+COMMON="
+ acct-user/mythtv
+ dev-libs/glib:2
+ dev-libs/lzo
+ dev-qt/qtcore:5
+ dev-qt/qtdbus:5
+ dev-qt/qtgui:5
+ dev-qt/qtnetwork:5
+ opengl? ( dev-qt/qtopengl:5 )
+ dev-qt/qtscript:5
+ dev-qt/qtsql:5[mysql]
+ dev-qt/qtwebkit:5
+ dev-qt/qtwidgets:5
+ dev-qt/qtxml:5
+ media-gfx/exiv2:=
+ media-libs/freetype:2
+ media-libs/libsamplerate
+ media-libs/taglib
+ lame? ( >=media-sound/lame-3.93.1 )
+ sys-libs/zlib
+ virtual/mysql
+ opengl? ( virtual/opengl )
+ X? (
+ x11-libs/libX11:=
+ x11-libs/libXext:=
+ x11-libs/libXinerama:=
+ x11-libs/libXrandr:=
+ x11-libs/libXv:=
+ x11-libs/libXxf86vm:=
+ x11-misc/wmctrl:=
+ )
+ alsa? ( >=media-libs/alsa-lib-1.0.24 )
+ bluray? (
+ media-libs/libbluray:=
+ dev-libs/libcdio:=
+ sys-fs/udisks:2
+ )
+ cec? ( dev-libs/libcec )
+ dvd? (
+ dev-libs/libcdio:=
+ sys-fs/udisks:2
+ )
+ egl? ( media-libs/mesa[egl] )
+ fftw? ( sci-libs/fftw:3.0=[threads] )
+ hdhomerun? ( media-libs/libhdhomerun )
+ ieee1394? (
+ >=media-libs/libiec61883-1.0.0
+ >=sys-libs/libavc1394-0.5.3
+ >=sys-libs/libraw1394-1.2.0
+ )
+ jack? ( media-sound/jack-audio-connection-kit )
+ lcd? ( app-misc/lcdproc )
+ libass? ( >=media-libs/libass-0.9.11:= )
+ lirc? ( app-misc/lirc )
+ perl? (
+ >=dev-perl/libwww-perl-5
+ dev-perl/DBD-mysql
+ dev-perl/HTTP-Message
+ dev-perl/IO-Socket-INET6
+ dev-perl/LWP-Protocol-https
+ dev-perl/Net-UPnP
+ )
+ pulseaudio? ( media-sound/pulseaudio )
+ python? (
+ ${PYTHON_DEPS}
+ dev-python/lxml
+ dev-python/mysql-python
+ dev-python/urlgrabber
+ dev-python/future
+ dev-python/requests-cache
+ )
+ systemd? ( sys-apps/systemd:= )
+ vaapi? ( x11-libs/libva:=[opengl] )
+ vdpau? ( x11-libs/libvdpau )
+ vpx? ( media-libs/libvpx:= )
+ x264? ( >=media-libs/x264-0.0.20111220:= )
+ x265? ( media-libs/x265 )
+ xml? ( >=dev-libs/libxml2-2.6.0 )
+ xvid? ( >=media-libs/xvid-1.1.0 )
+ zeroconf? (
+ dev-libs/openssl:0=
+ net-dns/avahi[mdnsresponder-compat]
+ )
+"
+RDEPEND="${COMMON}
+ media-fonts/corefonts
+ media-fonts/dejavu
+ media-fonts/liberation-fonts
+ x11-apps/xinit
+ autostart? (
+ net-dialup/mingetty
+ x11-apps/xset
+ x11-wm/evilwm
+ )
+ dvd? ( media-libs/libdvdcss )
+ xmltv? ( >=media-tv/xmltv-0.5.43 )
+"
+DEPEND="
+ ${COMMON}
+ dev-lang/yasm
+ x11-base/xorg-proto
+"
+
+BDEPEND="virtual/pkgconfig"
+
+PATCHES=(
+ "${FILESDIR}/${P}-respect_LDFLAGS.patch"
+ "${FILESDIR}/${P}-cast_constants_to_short.patch"
+ "${FILESDIR}/${P}-Fix_Dereferencing_type-punned_pointer.patch"
+ "${FILESDIR}/${P}-Fix_unitialized_variables.patch"
+)
+
+# mythtv and mythplugins are separate builds in the github mythtv project
+S="${WORKDIR}/${PF}/mythtv"
+
+DISABLE_AUTOFORMATTING="yes"
+DOC_CONTENTS="
+Creating mythtv MySQL user and mythconverg database if it does not
+already exist. You will be prompted for your MySQL root password.
+
+Mythtv is updated to use correct FHS/Gentoo policy paths.
+Updating mythtv installations may report:
+ * mythtv is in use, cannot update home
+ * There was an error when attempting to update the home directory for mythtv
+ * Please update it manually on your system (as root):
+ * usermod -d "/var/lib/mythtv" "mythtv"
+This can be ignored. The previous default was "/home/mythtv".
+Use caution if you change the home directory.
+
+To have this machine operate as recording host for MythTV,
+mythbackend must be running. Run the following:
+rc-update add mythbackend default
+
+Your recordings folder must be owned 'mythtv'. e.g.
+chown -R mythtv /var/lib/mythtv
+
+Want mythfrontend to start automatically?
+Set USE=autostart. Details can be found at:
+https://dev.gentoo.org/~cardoe/mythtv/autostart.html
+
+Note that the systemd unit now restarts by default and logs
+to journald via the console at the notice verbosity.
+"
+
+pkg_setup() {
+ python-single-r1_pkg_setup
+ # The acct-user/mythtv package creates/manages the user 'mythtv'
+}
+
+src_prepare() {
+ default
+
+ # Perl bits need to go into vender_perl and not site_perl
+ sed -e "s:pure_install:pure_install INSTALLDIRS=vendor:" \
+ -i "${S}"/bindings/perl/Makefile || die "Cannot convert site_perl to vendor_perl!"
+
+ # Fix up the version info since we are using the fixes/${PV} branch
+ echo "SOURCE_VERSION=\"v${MY_PV}\"" > "${S}"/VERSION
+ echo "BRANCH=\"${MYTHTV_BRANCH}\"" >> "${S}"/VERSION
+ echo "SOURCE_VERSION=\"${BACKPORTS}\"" > "${S}"/EXPORTED_VERSION
+ echo "BRANCH=\"${MYTHTV_BRANCH}\"" >> "${S}"/EXPORTED_VERSION
+
+ echo "setting.extra -= -ldconfig" >> "${S}"/programs/mythfrontend/mythfrontend.pro
+}
+
+src_configure() {
+ local -a myconf
+
+ # Setup paths
+ myconf+=(--prefix="${EPREFIX}"/usr)
+ myconf+=(--libdir="${EPREFIX}"/usr/$(get_libdir))
+ myconf+=(--libdir-name=$(get_libdir))
+ myconf+=(--mandir="${EPREFIX}"/usr/share/man)
+
+ if use debug; then
+ myconf+=(--compile-type=debug)
+ myconf+=(--disable-stripping) # FIXME: does not disable for all files, only for some
+ myconf+=(--enable-valgrind) # disables timeouts for valgrind memory debugging
+ else
+ myconf+=(--compile-type=release)
+ fi
+
+ # Build boosters
+ has ccache "${FEATURES}" || myconf+=(--disable-ccache)
+ has distcc "${FEATURES}" || myconf+=(--disable-distcc)
+
+ # CPU settings
+ # Mythtv's configure is borrowed from ffmpeg,
+ # Bug #172723
+ # Try to get cpu type based on CFLAGS.
+ # We need to do this so that features of that CPU will be better used
+ # If they contain an unknown CPU it will not hurt since ffmpeg's configure
+ # will just ignore it.
+ for i in $(get-flag march) $(get-flag mcpu) $(get-flag mtune) ; do
+ [ "${i}" = "native" ] && i="host" # bug #273421
+ myconf+=(--cpu="${i}")
+ break
+ done
+ myconf+=($(use_enable altivec))
+
+ # Sound Output Support
+ myconf+=(
+ $(use_enable oss audio-oss)
+ $(use_enable alsa audio-alsa)
+ $(use_enable jack audio-jack)
+ $(use_enable pulseaudio audio-pulseoutput)
+ )
+
+ # Input Support
+ myconf+=(
+ $(use_enable lirc)
+ $(use_enable input_devices_joystick joystick-menu)
+ $(use_enable cec libcec)
+ $(use_enable ieee1394 firewire)
+ $(use_enable hdhomerun)
+ $(use_enable vbox)
+ $(use_enable ceton)
+ $(use_enable v4l v4l2)
+ $(use_enable ivtv)
+ $(use_enable hdpvr)
+ $(use_enable dvb)
+ $(use_enable asi)
+ )
+
+ # Video Output Support
+ myconf+=(
+ $(use_enable X x11)
+ $(use_enable X xnvctrl)
+ $(use_enable X xrandr)
+ $(use_enable X xv)
+ )
+
+ # Hardware accellerators
+ myconf+=(
+ $(use_enable vdpau)
+ $(use_enable crystalhd)
+ $(use_enable vaapi)
+ $(use_enable vaapi vaapi2)
+ $(use_enable opengl opengl-video)
+ $(use_enable opengl opengl-themepainter)
+ $(use_enable libass)
+ )
+
+ # System tools
+ myconf+=(
+ $(use_enable systemd systemd_notify)
+ $(use_enable systemd systemd_journal)
+ $(use_enable xml libxml2)
+ $(use_enable zeroconf libdns-sd)
+ )
+
+ # Bindings
+ if use perl && use python; then
+ myconf+=(--with-bindings=perl,python)
+ elif use perl; then
+ myconf+=(--without-bindings=python)
+ myconf+=(--with-bindings=perl)
+ elif use python; then
+ myconf+=(--without-bindings=perl)
+ myconf+=(--with-bindings=python)
+ else
+ myconf+=(--without-bindings=perl,python)
+ fi
+ use python && myconf+=(--python="${EPYTHON}")
+ myconf+=($(use_enable java bdjava))
+
+ # External codec library options (used for mythffmpeg and streaming transcode)
+ # lame is required for some broadcasts for silence detection of commercials
+ # default enable in IUSE with +lame
+ myconf+=(
+ $(use_enable lame libmp3lame)
+ $(use_enable xvid libxvid)
+ $(use_enable x264 libx264)
+ $(use_enable x265 libx265)
+ $(use_enable vpx libvpx)
+ )
+
+ # Clean up DSO load times and other compiler bits
+ myconf+=(--enable-symbol-visibility)
+ myconf+=(--enable-pic)
+
+ if tc-is-cross-compiler ; then
+ myconf+=(--enable-cross-compile --arch=$(tc-arch-kernel))
+ myconf+=(--cross-prefix="${CHOST}"-)
+ fi
+
+ myconf+=($(use_enable bluray libbluray_external))
+
+ einfo "Running ./configure ${myconf[@]} - THIS MAY TAKE A WHILE."
+ ./configure \
+ --cc="$(tc-getCC)" \
+ --cxx="$(tc-getCXX)" \
+ --ar="$(tc-getAR)" \
+ --extra-cflags="${CFLAGS}" \
+ --extra-cxxflags="${CXXFLAGS}" \
+ --extra-ldflags="${LDFLAGS}" \
+ --qmake=$(qt5_get_bindir)/qmake \
+ "${myconf[@]}"
+}
+
+src_install() {
+ emake STRIP="true" INSTALL_ROOT="${D}" install
+ dodoc AUTHORS UPGRADING README
+ readme.gentoo_create_doc
+
+ insinto /usr/share/mythtv/database
+ doins database/*
+
+ newinitd "${FILESDIR}"/mythbackend.init-r2 mythbackend
+ newconfd "${FILESDIR}"/mythbackend.conf-r1 mythbackend
+ if use systemd; then
+ systemd_newunit "${FILESDIR}"/mythbackend.service-28 mythbackend.service
+ fi
+
+ dodoc keys.txt
+
+ keepdir /etc/mythtv
+ fowners -R mythtv /etc/mythtv
+ keepdir /var/log/mythtv
+ fowners -R mythtv /var/log/mythtv
+
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}"/mythtv.logrotate.d-r4 mythtv
+
+ insinto /usr/share/mythtv/contrib
+ # Ensure we don't install scripts needing the perl bindings (bug #516968)
+ use perl || find contrib/ -name '*.pl' -exec rm -f {} \;
+ # Ensure we don't install scripts needing the python bindings (bug #516968)
+ use python || find contrib/ -name '*.py' -exec rm -f {} \;
+ doins -r contrib/*
+
+ # Install our mythfrontend wrapper which is similar to Mythbuntu's
+ if use wrapper; then
+ mv "${ED}/usr/bin/mythfrontend" "${ED}/usr/bin/mythfrontend.real" || die "Failed to install mythfrontend.real"
+ newbin "${FILESDIR}"/mythfrontend.wrapper mythfrontend
+ newconfd "${FILESDIR}"/mythfrontend.conf mythfrontend
+ fi
+
+ if use autostart; then
+ local mythtv_homedir="$( egethome mythtv )"
+
+ echo CONFIG_PROTECT="\"${mythtv_homedir}\"" > "${T}"/95mythtv
+ doenvd "${T}"/95mythtv
+
+ insinto "${mythtv_homedir}"
+ newins "${FILESDIR}"/bash_profile .bash_profile
+ newins "${FILESDIR}"/xinitrc-r1 .xinitrc
+ fi
+
+ # Make Python files executable
+ find "${ED}/usr/share/mythtv" -type f -name '*.py' | while read file; do
+ if [[ ! "${file##*/}" = "__init__.py" ]]; then
+ chmod a+x "${file}" || die "Failed to make python file $(basename ${file}) executable"
+ fi
+ done
+
+ # Ensure that Python scripts are executed by Python 2
+ python_fix_shebang "${ED}/usr/share/mythtv"
+
+ # Make shell & perl scripts executable
+ find "${ED}" -type f -name '*.sh' -o -type f -name '*.pl' | \
+ while read file; do
+ chmod a+x "${file}" || die
+ done
+}
+
+pkg_preinst() {
+ export CONFIG_PROTECT="${CONFIG_PROTECT} ${EROOT}$( egethome mythtv )"
+}
+
+pkg_postinst() {
+ readme.gentoo_print_elog
+}
+
+pkg_info() {
+ return
+}
+
+pkg_config() {
+ "${EROOT}"/usr/bin/mysql -u root -p < "${EROOT}"/usr/share/mythtv/database/mc.sql
+}